' *************************************************************************************
'     Copyright Christopher R. Boss, 2003 to 2006
'        All Rights Reserved !   Code may NOT be posted in any public forum !
' *************************************************************************************
#COMPILE EXE
#DIM ALL
' --------------------
#INCLUDE "C:\ezgui40pro\includes\ezgui40.inc"
' --------------------
$SpriteImages  =   "logo1.bmp|bg01.bmp|ball3d.bmp"
'
DECLARE SUB Form1_Display(BYVAL Parent$)
DECLARE SUB Form1_Design()
DECLARE SUB Form1_Events(CID&, CMsg&, CVal&, Cancel&)
DECLARE SUB SpriteDraw(BYVAL Mode&)
DECLARE SUB MakeSprites()
%FORM1_CANVAS1            = 100
DECLARE SUB FORM1_CANVAS1_Draw(BYVAL Mode&)
'
' --------------------
#INCLUDE "C:\ezgui40pro\includes\ezwmain.inc"
' --------------------
'
#INCLUDE "C:\ezgui 4 demos\reg.inc"

GLOBAL App_OffsetX&
GLOBAL App_OffsetY&
GLOBAL App_MoveFlag&
GLOBAL App_MouseX&
GLOBAL App_MouseY&
GLOBAL App_BitmapW&
GLOBAL App_Width AS LONG
GLOBAL App_Height AS LONG

SUB EZ_Main(VerNum&)
    LOCAL W&, H&
    EZ_Reg %EZ4_CUST, %EZ4_REG
    EZ_GetScreenSize W&, H&
    App_Width=EZ_CX(W&)-15
    App_Height=EZ_CY(H&)-8
    EZ_AllowMouseMoveEvents 1
    EZ_AllowCursorEvents 1
    EZ_DefImageFolder "graphics"
    Form1_Display ""
END SUB
'
SUB EZ_DesignWindow(FormName$)
    SELECT CASE FormName$
        CASE "FORM1"
            Form1_Design
        CASE ELSE
    END SELECT
END SUB
'
SUB EZ_Events(FormName$, CID&, CMsg&, CVal&, Cancel&)
    SELECT CASE FormName$
        CASE "FORM1"
            Form1_Events CID&, CMsg&, CVal&, Cancel&
        CASE ELSE
    END SELECT
END SUB
'
SUB Form1_Display(BYVAL Parent$)
    EZ_Color 0, 9
    EZ_Form "FORM1", Parent$, "Screen Captured for Background. Drag Sprites around with Mouse !", 0, 0, App_Width, App_Height, "CK"
END SUB
'
SUB Form1_Design()
    EZ_Color 0, 30
    EZ_SubClass 2
    EZ_Canvas %FORM1_CANVAS1, 2, 1, App_Width-4, App_Height-2, "S{DIB}"
    EZ_SubClass 0
    FORM1_CANVAS1_Draw -1
END SUB
'

SUB Form1_Events(CID&, CMsg&, CVal&, Cancel&)
    LOCAL X&, Y&, SX&, SY&
    STATIC SPN$
    SELECT CASE CID&
        CASE %EZ_Window
            IF CMsg&=%EZ_Started THEN
                MakeSprites
            END IF
        CASE  %FORM1_CANVAS1
            IF CMsg&=%EZ_SelectCursor THEN
                IF App_MoveFlag&=0 THEN
                    SPN$ = EZ_TestSpriteClick ("Form1", %FORM1_CANVAS1, App_MouseX&, App_MouseY&)
                    IF SPN$<>"" THEN
                        EZ_SetCursor "", 4
                        Cancel&=1
                    END IF
                END IF
            END IF
            IF CMsg&=%EZ_LButtonDown THEN
                EZ_GetMouseXY CVal&, X&, Y&
                SPN$ = EZ_TestSpriteClick ("Form1", %FORM1_CANVAS1, X&, Y&)
                IF SPN$<>"" THEN
                    IF EZ_GetSpriteXY (SPN$, SX&, SY&) THEN
                        EZ_SetCaptureEx EZ_Handle("Form1", %FORM1_CANVAS1)
                        EZ_SetCursor "", 1
                        App_MoveFlag&=1
                        App_OffsetX&=X&-SX&
                        App_OffsetY&=Y&-SY&
                    END IF
                END IF
            END IF
            IF CMsg&=%EZ_MouseMove THEN
                EZ_GetMouseXY CVal&, X&, Y&
                App_MouseX&=X&
                App_MouseY&=Y&
                IF App_MoveFlag& THEN
                    EZ_MoveSprites SPN$, X&-App_OffsetX&, Y&-App_OffsetY&, 0
                    EZ_UpdateClient "Form1", %FORM1_CANVAS1
                END IF
            END IF
            IF CMsg&=%EZ_LButtonUp THEN
                App_MoveFlag&=0
                EZ_SetCaptureEx 0
            END IF
        CASE ELSE
    END SELECT
END SUB

FUNCTION CaptureScreen(BYVAL CW&, BYVAL CH&) AS STRING
    LOCAL P$, hDC&, hDCP&
    P$=EZ_CreatePicture(CW&, CH&)
    hDCP&=EZ_StartPictureDraw(P$)
        hDC&=EZ_StartWindowDraw("",0,"")
            EZ_SetDrawMode 2,0
            EZ_DCCopyBlock hDC& ,0, 0, CW&, CH&, hDCP&, 0,0
        EZ_EndWindowDraw
    EZ_EndPictureDraw
    FUNCTION=P$
END FUNCTION

SUB FORM1_CANVAS1_Draw(BYVAL Mode&)
    LOCAL CW&, CH&, P$, hDC&, hDCP&
    IF Mode&=-1 THEN
        EZ_GetCanvasSize "Form1", %FORM1_CANVAS1, CW&, CH&
        P$=CaptureScreen(CW&, CH&)
        EZ_StartDraw "Form1", %FORM1_CANVAS1, CW&, CH&, ""
            EZ_CDrawPicture 0,0, CW&, CH&, P$,""
        EZ_EndDraw
        EZ_FreeImage P$
    END IF
END SUB

SUB MakeSprites()
    LOCAL CT&, N&, P$, SName$, EF&
    CT&=PARSECOUNT($SpriteImages,"|")
    EZ_InitSpriteBuffers CT&,-1,-1
    FOR N&=1 TO CT&
        P$=EZ_LoadPicture(TRIM$(PARSE$($SpriteImages,"|",N&)))
        IF P$<>"" THEN
            SName$="SP"+TRIM$(STR$(N&))
            EZ_DefSpriteByPict  SName$, P$, 1, -1, 80
            EZ_MoveSprites SName$, N&*24,N&*24,0
            EZ_FreeImage P$
            EZ_AssignSprites "Form1", %FORM1_CANVAS1, SName$
            IF (N& MOD 2) <> 0 THEN EF&=100 ELSE EF&=40
            EZ_SetSpritesEffect SName$, EF&,0
            EZ_ShowSprites SName$,1
        END IF
    NEXT N&
END SUB
